from secrets import randbits
from math import ceil
from hashlib import sha256

# Hash of the secret to validate your input
SECRET_HASH = "024583320fa32637ff877ea5b3d1dc240bbdb16b6a538193968a6d43c72ecdaf"

def split(secret, shares, threshold):
    coefficients = [randbits(27) for _ in range(threshold - 1)]
    def solve(x, i):
        if i == -1:
            return secret
        return x**(i + 1) * coefficients[i] + solve(x, i-1)
    def f(x):
        return solve(x, len(coefficients) - 1)
    # Start at x+1 because f(0) would be the secret.
    return [f(x+1) for x in range(shares)]

MESSAGE = """
Ok, so you solved the last challenge and since then I gave out the shares to my
friends. Somehow though, instead of the three required, *two* of them got
together and managed to figure out the flag! Can you do the same?

Here's the code I ran:

  split(<secret>, 5, 3)

Which again returned 5 shares, but I'll only give you two:

  3035936465959343037272924822253140001629634445529032403792668837441702784821884318119
  3035936465959343037272924822253140001629634445529032403792668837441702784822253997733
"""

if __name__ == "__main__":
    print(MESSAGE)
    secret = input("Of course I can, here's the secret: ")
    if sha256(secret.encode()).hexdigest() != SECRET_HASH:
        print("Hmm, not quite right, but I'm sure my code works!")
    else:
        print("That's right! Here's the flag:")
        print(f"CTF{{{secret}}}")
        print("Guess my secret sharing scheme isn't so great after all. Go use Shamir's!")
